import PropTypes from 'prop-types';
import styled from 'styled-components';

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var CSSGlobals = ["inherit", "initial", "unset"];
var SelfPosition = ["start", "end", "flex-start", "flex-end", "self-start", "self-end", "center"];
var ContentPosition = ["start", "end", "flex-start", "flex-end", "center", "left", "right"];
var BaseLinePosition = ["baseline", "first baseline", "last baseline"];
var Direction = ["row", "column", "row-reverse", "column-reverse"];
var Wrap = ["nowrap", "wrap", "wrap-reverse"];

var _templateObject$1;
var Flex = styled("div")(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteral(["\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n"])), function (_ref) {
  var inline = _ref.inline;
  return "\n display: ".concat(inline ? "inline-flex" : "flex", ";\n ");
}, function (_ref2) {
  var direction = _ref2.direction;
  return direction && "flex-direction: ".concat(direction, ";");
}, function (_ref3) {
  var alignItems = _ref3.alignItems;
  return alignItems && "align-items: ".concat(alignItems, ";");
}, function (_ref4) {
  var justifyContent = _ref4.justifyContent;
  return justifyContent && "justify-content: ".concat(justifyContent, ";");
}, function (_ref5) {
  var wrap = _ref5.wrap;
  return wrap && "flex-wrap: ".concat(wrap, ";");
}, function (_ref6) {
  var flow = _ref6.flow;
  return flow && "flex-flow: ".concat(flow, ";");
}, function (_ref7) {
  var gap = _ref7.gap;
  return gap && "gap: ".concat(gap, ";");
}, function (_ref8) {
  var rowGap = _ref8.rowGap;
  return rowGap && "row-gap: ".concat(rowGap, ";");
}, function (_ref9) {
  var columnGap = _ref9.columnGap;
  return columnGap && "column-gap: ".concat(columnGap, ";");
});
Flex.propTypes = {
  as: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  inline: PropTypes.bool,
  direction: PropTypes.oneOf([].concat(_toConsumableArray(Direction), _toConsumableArray(CSSGlobals))),
  alignItems: PropTypes.oneOf(["normal", "stretch"].concat(_toConsumableArray(BaseLinePosition), _toConsumableArray(SelfPosition), _toConsumableArray(SelfPosition.map(function (pos) {
    return "safe ".concat(pos);
  })), _toConsumableArray(SelfPosition.map(function (pos) {
    return "unsafe ".concat(pos);
  })), _toConsumableArray(CSSGlobals))),
  justifyContent: PropTypes.oneOf(["space-between", "space-around", "space-evenly", "stretch", "normal"].concat(_toConsumableArray(ContentPosition), _toConsumableArray(ContentPosition.map(function (pos) {
    return "safe ".concat(pos);
  })), _toConsumableArray(ContentPosition.map(function (pos) {
    return "unsafe ".concat(pos);
  })), _toConsumableArray(CSSGlobals))),
  wrap: PropTypes.oneOf([].concat(_toConsumableArray(Wrap), _toConsumableArray(CSSGlobals))),
  flow: PropTypes.oneOf([].concat(_toConsumableArray(Wrap), _toConsumableArray(Direction), _toConsumableArray(Direction.reduce(function (flow, direction) {
    return [].concat(_toConsumableArray(flow), _toConsumableArray(Wrap.map(function (wrap) {
      return "".concat(direction, " ").concat(wrap);
    })));
  }, [])), _toConsumableArray(CSSGlobals))),
  gap: PropTypes.string,
  rowGap: PropTypes.string,
  columnGap: PropTypes.string
};
Flex.defaultProps = {
  inline: false
};

var _templateObject;

var isNumberOrString = function isNumberOrString(value) {
  return typeof value === "number" || typeof value === "string";
};

var Item = styled("div")(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n"])), function (_ref) {
  var order = _ref.order;
  return isNumberOrString(order) && "order: ".concat(order, ";");
}, function (_ref2) {
  var alignSelf = _ref2.alignSelf;
  return alignSelf && "align-self: ".concat(alignSelf, ";");
}, function (_ref3) {
  var grow = _ref3.grow;
  return isNumberOrString(grow) && "flex-grow: ".concat(grow, ";");
}, function (_ref4) {
  var shrink = _ref4.shrink;
  return isNumberOrString(shrink) && "flex-shrink: ".concat(shrink, ";");
}, function (_ref5) {
  var basis = _ref5.basis;
  return basis && "flex-basis: ".concat(basis, ";");
}, function (_ref6) {
  var flex = _ref6.flex;
  return isNumberOrString(flex) && "flex: ".concat(flex, ";");
});
Item.propTypes = {
  as: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  order: PropTypes.number,
  alignSelf: PropTypes.oneOf(["auto", "normal", "stretch"].concat(_toConsumableArray(BaseLinePosition), _toConsumableArray(SelfPosition), _toConsumableArray(SelfPosition.map(function (pos) {
    return "safe ".concat(pos);
  })), _toConsumableArray(SelfPosition.map(function (pos) {
    return "unsafe ".concat(pos);
  })), _toConsumableArray(CSSGlobals))),
  grow: PropTypes.oneOfType([PropTypes.oneOf(CSSGlobals), PropTypes.number]),
  shrink: PropTypes.oneOfType([PropTypes.oneOf(CSSGlobals), PropTypes.number]),
  basis: PropTypes.string,
  flex: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};

export { Flex, Item };
//# sourceMappingURL=index.es.js.map
